// Don't load these modals too soon
ko.scc.getRepositoryRoot(); // scc is slow, we want to get a head start
ko.workspace2.waitForProjectManager(function() {
    var commit = document.getElementById('scc-tab-commit'),
        history = document.getElementById('scc-tab-history'),
        historyFile = document.getElementById('scc-tab-history-file'),
        log = document.getElementById('scc-tab-log');
    commit.setAttribute("src", commit.getAttribute("_src"));
    history.setAttribute("src", history.getAttribute("_src"));
    historyFile.setAttribute("src", historyFile.getAttribute("_src"));
    log.setAttribute("src", log.getAttribute("_src"));
});

var setState = function (retry = true)
{
    var enabled = !! ko.scc.getCurrentService();
    document.getElementById("deck").setAttribute("selectedIndex", enabled ? 0 : 1);
    
    // Retry grabbing SCC info after 2 seconds
    // This is to deal with our flaky async SCC
    if ( ! enabled && retry)
        setTimeout(setState.bind(null, false), 2000);
};

var w = require("ko/windows").getMain();
w.addEventListener("current_place_opened", setState);
w.addEventListener("SCC", setState);
window.addEventListener("load", setState);

var observer = {
    observe: function (subject, topic, data)
    {
        var url = ko.scc.getRepositoryRoot();
        
        var reload = false;
        var urllist = data.split('\n');
        for (let u of urllist) {
            if (u.indexOf(url) === 0)
            {
                reload = true;
                break;
            }
        }
        
        if (reload)
        {
            setState(false);
        }
    }
};

var observerSvc = Components.classes["@mozilla.org/observer-service;1"]
                                .getService(Components.interfaces.nsIObserverService);
observerSvc.addObserver(observer, "file_status", false);